#pragma once

#include "AboutDlg.h"
#include "StringDlg.h"

namespace VFSEditor
{
	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;
	using namespace System::Threading;

	/// <summary> 
	/// Summary for Form1
	///
	/// WARNING: If you change the name of this class, you will need to change the 
	///          'Resource File Name' property for the managed resource compiler tool 
	///          associated with all .resx files this class depends on.  Otherwise,
	///          the designers will not be able to interact properly with localized
	///          resources associated with this form.
	/// </summary>
	public __gc class Form1 : public System::Windows::Forms::Form
	{	
	public:
		Form1(void)
		{
			InitializeComponent();
			this->aboutDlg = new AboutDlg();
			this->dataidxDlg = new StringDlg();
			this->dataidxDlg->setDefaultString(S"data.idx");
		}
  
	protected:
		void Dispose(Boolean disposing)
		{
			if (disposing && components)
			{
				components->Dispose();
			}

			RemoveTempDir();

			__super::Dispose(disposing);
		}

	private: System::Void RemoveTempDir();

	private: System::Windows::Forms::TextBox *  OutPutPanel;

	private: System::Windows::Forms::TreeView *  VFSFileTree;

	private: System::Windows::Forms::FolderBrowserDialog *  ExtractAllDialog;

	private: System::Windows::Forms::SaveFileDialog *  ExtractFileDialog;



	private: System::Windows::Forms::MenuItem *  FileMenu;

	private: System::Windows::Forms::MenuItem *  HelpMenu;

	private: System::Windows::Forms::MenuItem *  menuItem5;
	private: System::Windows::Forms::MenuItem *  menuItem6;
	private: System::Windows::Forms::MenuItem *  menuItem7;
	private: System::Windows::Forms::MenuItem *  menuItem8;
	private: System::Windows::Forms::MenuItem *  menuQuit;
	private: System::Windows::Forms::MenuItem *  menuAbout;

	private:
		/// <summary>
		/// Required designer variable.
		/// </summary>
		System::ComponentModel::Container * components;
	private: System::Windows::Forms::MainMenu *  mainMenu;
	private: System::Windows::Forms::ContextMenu *  contextList;
	private: System::Windows::Forms::MenuItem *  menuContentExtract;
	private: System::Windows::Forms::MenuItem *  menuItem1;
	private: System::Windows::Forms::MenuItem *  menuItem2;

	private:
		AboutDlg *aboutDlg;
		StringDlg *dataidxDlg;



	private: System::Windows::Forms::MenuItem *  OptionsMenu;
	private: System::Windows::Forms::MenuItem *  menuItem3;
	private: System::Windows::Forms::MenuItem *  menuItem4;
	private: System::Windows::Forms::MenuItem *  menuItem9;
	private: System::Windows::Forms::MenuItem *  menuSetIndex;





		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		void InitializeComponent(void)
		{
			System::Resources::ResourceManager *  resources = new System::Resources::ResourceManager(__typeof(VFSEditor::Form1));
			this->OutPutPanel = new System::Windows::Forms::TextBox();
			this->VFSFileTree = new System::Windows::Forms::TreeView();
			this->contextList = new System::Windows::Forms::ContextMenu();
			this->menuContentExtract = new System::Windows::Forms::MenuItem();
			this->menuItem1 = new System::Windows::Forms::MenuItem();
			this->menuItem2 = new System::Windows::Forms::MenuItem();
			this->ExtractAllDialog = new System::Windows::Forms::FolderBrowserDialog();
			this->ExtractFileDialog = new System::Windows::Forms::SaveFileDialog();
			this->mainMenu = new System::Windows::Forms::MainMenu();
			this->FileMenu = new System::Windows::Forms::MenuItem();
			this->menuItem6 = new System::Windows::Forms::MenuItem();
			this->menuItem3 = new System::Windows::Forms::MenuItem();
			this->menuItem7 = new System::Windows::Forms::MenuItem();
			this->menuItem8 = new System::Windows::Forms::MenuItem();
			this->menuItem9 = new System::Windows::Forms::MenuItem();
			this->menuItem4 = new System::Windows::Forms::MenuItem();
			this->menuItem5 = new System::Windows::Forms::MenuItem();
			this->menuQuit = new System::Windows::Forms::MenuItem();
			this->OptionsMenu = new System::Windows::Forms::MenuItem();
			this->menuSetIndex = new System::Windows::Forms::MenuItem();
			this->HelpMenu = new System::Windows::Forms::MenuItem();
			this->menuAbout = new System::Windows::Forms::MenuItem();
			this->SuspendLayout();
			// 
			// OutPutPanel
			// 
			this->OutPutPanel->AcceptsReturn = true;
			this->OutPutPanel->AcceptsTab = true;
			this->OutPutPanel->Dock = System::Windows::Forms::DockStyle::Bottom;
			this->OutPutPanel->Location = System::Drawing::Point(0, 358);
			this->OutPutPanel->Multiline = true;
			this->OutPutPanel->Name = S"OutPutPanel";
			this->OutPutPanel->ReadOnly = true;
			this->OutPutPanel->ScrollBars = System::Windows::Forms::ScrollBars::Vertical;
			this->OutPutPanel->Size = System::Drawing::Size(416, 104);
			this->OutPutPanel->TabIndex = 4;
			this->OutPutPanel->Text = S"";
			// 
			// VFSFileTree
			// 
			this->VFSFileTree->Anchor = (System::Windows::Forms::AnchorStyles)(((System::Windows::Forms::AnchorStyles::Top | System::Windows::Forms::AnchorStyles::Bottom) 
				| System::Windows::Forms::AnchorStyles::Left) 
				| System::Windows::Forms::AnchorStyles::Right);
			this->VFSFileTree->ContextMenu = this->contextList;
			this->VFSFileTree->FullRowSelect = true;
			this->VFSFileTree->HideSelection = false;
			this->VFSFileTree->HotTracking = true;
			this->VFSFileTree->ImageIndex = -1;
			this->VFSFileTree->Location = System::Drawing::Point(0, 0);
			this->VFSFileTree->Name = S"VFSFileTree";
			System::Windows::Forms::TreeNode* __mcTemp__1[] = new System::Windows::Forms::TreeNode*[1];
			__mcTemp__1[0] = new System::Windows::Forms::TreeNode(S"Empty");
			this->VFSFileTree->Nodes->AddRange(__mcTemp__1);
			this->VFSFileTree->SelectedImageIndex = -1;
			this->VFSFileTree->Size = System::Drawing::Size(416, 352);
			this->VFSFileTree->Sorted = true;
			this->VFSFileTree->TabIndex = 6;
			this->VFSFileTree->MouseUp += new System::Windows::Forms::MouseEventHandler(this, VFSFileTree_MouseUp);
			this->VFSFileTree->DoubleClick += new System::EventHandler(this, VFSFileTree_DoubleClick);
			// 
			// contextList
			// 
			System::Windows::Forms::MenuItem* __mcTemp__2[] = new System::Windows::Forms::MenuItem*[3];
			__mcTemp__2[0] = this->menuContentExtract;
			__mcTemp__2[1] = this->menuItem1;
			__mcTemp__2[2] = this->menuItem2;
			this->contextList->MenuItems->AddRange(__mcTemp__2);
			this->contextList->Popup += new System::EventHandler(this, contextList_Popup);
			// 
			// menuContentExtract
			// 
			this->menuContentExtract->Index = 0;
			this->menuContentExtract->Text = S"Extract";
			this->menuContentExtract->Click += new System::EventHandler(this, menuContentExtract_Click);
			// 
			// menuItem1
			// 
			this->menuItem1->Enabled = false;
			this->menuItem1->Index = 1;
			this->menuItem1->Text = S"Add";
			// 
			// menuItem2
			// 
			this->menuItem2->Enabled = false;
			this->menuItem2->Index = 2;
			this->menuItem2->Text = S"Delete";
			this->menuItem2->Click += new System::EventHandler(this, menuItem2_Click);
			// 
			// ExtractAllDialog
			// 
			this->ExtractAllDialog->Description = S"Extract all files to";
			this->ExtractAllDialog->SelectedPath = S"D:\\Code\\Projects\\My\\VFSEditor";
			// 
			// ExtractFileDialog
			// 
			this->ExtractFileDialog->OverwritePrompt = false;
			this->ExtractFileDialog->RestoreDirectory = true;
			// 
			// mainMenu
			// 
			System::Windows::Forms::MenuItem* __mcTemp__3[] = new System::Windows::Forms::MenuItem*[3];
			__mcTemp__3[0] = this->FileMenu;
			__mcTemp__3[1] = this->OptionsMenu;
			__mcTemp__3[2] = this->HelpMenu;
			this->mainMenu->MenuItems->AddRange(__mcTemp__3);
			// 
			// FileMenu
			// 
			this->FileMenu->Index = 0;
			System::Windows::Forms::MenuItem* __mcTemp__4[] = new System::Windows::Forms::MenuItem*[8];
			__mcTemp__4[0] = this->menuItem6;
			__mcTemp__4[1] = this->menuItem3;
			__mcTemp__4[2] = this->menuItem7;
			__mcTemp__4[3] = this->menuItem8;
			__mcTemp__4[4] = this->menuItem9;
			__mcTemp__4[5] = this->menuItem4;
			__mcTemp__4[6] = this->menuItem5;
			__mcTemp__4[7] = this->menuQuit;
			this->FileMenu->MenuItems->AddRange(__mcTemp__4);
			this->FileMenu->Text = S"&File";
			// 
			// menuItem6
			// 
			this->menuItem6->Index = 0;
			this->menuItem6->Text = S"&Load file structure from index";
			this->menuItem6->Click += new System::EventHandler(this, menuItem6_Click);
			// 
			// menuItem3
			// 
			this->menuItem3->Index = 1;
			this->menuItem3->Text = S"-";
			// 
			// menuItem7
			// 
			this->menuItem7->Index = 2;
			this->menuItem7->Text = S"&Extract File";
			this->menuItem7->Click += new System::EventHandler(this, menuItem7_Click);
			// 
			// menuItem8
			// 
			this->menuItem8->Index = 3;
			this->menuItem8->Text = S"Extract All";
			this->menuItem8->Click += new System::EventHandler(this, menuItem8_Click);
			// 
			// menuItem9
			// 
			this->menuItem9->Enabled = false;
			this->menuItem9->Index = 4;
			this->menuItem9->Text = S"&Add File";
			// 
			// menuItem4
			// 
			this->menuItem4->Enabled = false;
			this->menuItem4->Index = 5;
			this->menuItem4->Text = S"&Delete File";
			this->menuItem4->Click += new System::EventHandler(this, menuItem4_Click);
			// 
			// menuItem5
			// 
			this->menuItem5->Index = 6;
			this->menuItem5->Text = S"-";
			// 
			// menuQuit
			// 
			this->menuQuit->Index = 7;
			this->menuQuit->Text = S"&Quit";
			this->menuQuit->Click += new System::EventHandler(this, menuQuit_Click);
			// 
			// OptionsMenu
			// 
			this->OptionsMenu->Index = 1;
			System::Windows::Forms::MenuItem* __mcTemp__5[] = new System::Windows::Forms::MenuItem*[1];
			__mcTemp__5[0] = this->menuSetIndex;
			this->OptionsMenu->MenuItems->AddRange(__mcTemp__5);
			this->OptionsMenu->Text = S"&Options";
			// 
			// menuSetIndex
			// 
			this->menuSetIndex->Index = 0;
			this->menuSetIndex->Text = S"Set &Index file";
			this->menuSetIndex->Click += new System::EventHandler(this, menuSetIndex_Click);
			// 
			// HelpMenu
			// 
			this->HelpMenu->Index = 2;
			System::Windows::Forms::MenuItem* __mcTemp__6[] = new System::Windows::Forms::MenuItem*[1];
			__mcTemp__6[0] = this->menuAbout;
			this->HelpMenu->MenuItems->AddRange(__mcTemp__6);
			this->HelpMenu->Text = S"&Help";
			// 
			// menuAbout
			// 
			this->menuAbout->Index = 0;
			this->menuAbout->Text = S"About";
			this->menuAbout->Click += new System::EventHandler(this, menuAbout_Click);
			// 
			// Form1
			// 
			this->AutoScaleBaseSize = System::Drawing::Size(5, 13);
			this->ClientSize = System::Drawing::Size(416, 462);
			this->Controls->Add(this->VFSFileTree);
			this->Controls->Add(this->OutPutPanel);
			this->Icon = (__try_cast<System::Drawing::Icon *  >(resources->GetObject(S"$this.Icon")));
			this->Menu = this->mainMenu;
			this->Name = S"Form1";
			this->Text = S"VFSEditor by Sniper/S";
			this->Load += new System::EventHandler(this, Form1_Load);
			this->ResumeLayout(false);

		}	


	private: System::Void OpenVFSDLL();
	private: System::Void ShowFiles();
	private: System::Void ExtractAll( String * path );
	private: System::Boolean Extract( String * ifilename, String * ofilename );
	private: const char *GetIndexFile();

	private: System::Void loadIdx()
			 {
				try
				{
					ShowFiles();
				}
				catch(...)
				{
					OutPutPanel->AppendText(S"List files failed. Maybe VFS File corrupt?\r\n");
					this->set_Enabled( true );
				}
			 }

	private: System::Void extractSelected()
			 {
				TreeNode * node = VFSFileTree->SelectedNode;
				if( node )
				{
					ExtractFileDialog->FileName = node->Text;
					enum DialogResult result = ExtractFileDialog->ShowDialog();
					if( result == DialogResult::OK )
					{
						String *path = node->FullPath;
						try
						{
							path = path->Substring(5, path->Length - 5);
							Extract(path, ExtractFileDialog->get_FileName() );
						}
						catch(...)
						{
							OutPutPanel->AppendText(S"failed\r\n");
							this->set_Enabled( true );
						}
					}
					else
					{
						OutPutPanel->AppendText(S"aborted\r\n");
					}
				}
			 }

	private: System::Void deleteSelected()
			{
				TreeNode * node = VFSFileTree->SelectedNode;
				if( node )
				{
					//ExtractFileDialog->FileName = node->Text;
					//enum DialogResult result = ExtractFileDialog->ShowDialog();
					//if( result == DialogResult::OK )
					{
						String *path = node->FullPath;
						try
						{
							path = path->Substring(5, path->Length - 5);
							DelFile( path );
						}
						catch(...)
						{
							OutPutPanel->AppendText(S"failed\r\n");
							this->set_Enabled( true );
						}
					}
					//else
					//{
					//	OutPutPanel->AppendText(S"aborted\r\n");
					//}
				}
			}

private: System::Void DelFile( String * file );

private: System::Void Form1_Load(System::Object *  sender, System::EventArgs *  e)
		 {
			 OpenVFSDLL();
			 loadIdx();
		 }

private: System::Void menuQuit_Click(System::Object *  sender, System::EventArgs *  e)
		 {
			 this->Dispose( true );			
		 }

private: System::Void menuAbout_Click(System::Object *  sender, System::EventArgs *  e)
		 {
			 this->aboutDlg->ShowDialog();
		 }

private: System::Void menuItem6_Click(System::Object *  sender, System::EventArgs *  e)
		 {
			 loadIdx();
		 }



private: System::Void menuContentExtract_Click(System::Object *  sender, System::EventArgs *  e)
		 {
			extractSelected();
		 }

private: System::Void menuSetIndex_Click(System::Object *  sender, System::EventArgs *  e)
		 {
			dataidxDlg->ShowDialog();
		 }



private: System::Void VFSFileTree_DoubleClick(System::Object *  sender, System::EventArgs *  e);

	private: System::Void menuItem8_Click(System::Object *  sender, System::EventArgs *  e)
		 {
 			 enum DialogResult result = ExtractAllDialog->ShowDialog();

			 if( result == DialogResult::OK )
			 {
				String *path = ExtractAllDialog->get_SelectedPath();
				OutPutPanel->AppendText(S"extracting to:\"");
				OutPutPanel->AppendText(path);
				OutPutPanel->AppendText(S"\"...\r\n");
				ExtractAll( path );
			 }
			 else
			 {
				  OutPutPanel->AppendText(S"aborted\r\n");
			 }
		 }

private: System::Void menuItem7_Click(System::Object *  sender, System::EventArgs *  e)
		 {
			 extractSelected();
		 }

private: System::Void menuItem4_Click(System::Object *  sender, System::EventArgs *  e)
		 {
			 deleteSelected();
		 }

private: System::Void menuItem2_Click(System::Object *  sender, System::EventArgs *  e)
		 {
			 deleteSelected();
		 }

private: System::Void contextList_Popup(System::Object *  sender, System::EventArgs *  e)
		 {
		 }

private: System::Void VFSFileTree_MouseUp(System::Object *  sender, System::Windows::Forms::MouseEventArgs *  e)
		 {
			if ( e->Button != MouseButtons::Right ) 
				 return;

			System::Drawing::Point pt( e->X, e->Y );
			VFSFileTree->PointToClient( pt );
			TreeNode *node = VFSFileTree->GetNodeAt( pt );

			if ( node == NULL ) 
				return;

			if ( node->Bounds.Contains( pt ) )
			{
				VFSFileTree->SelectedNode = node;
				this->contextList->Show( VFSFileTree, pt );
			}
		 }
};
}


